<?php
use \Homegear\Homegear as Homegear;

$hg = new Homegear();
$id = (isset($_REQUEST['id']) ? $_REQUEST['id'] : null);
$type = (isset($_REQUEST['type']) ? $_REQUEST['type'] : null);

header('Content-Type: application/json');
if ($type === null || $id === null) {
    echo json_encode(['status' => 'error', 'message' => 'id or type missing']);
    exit(0);
}
try {
    $result = $hg->managementGetCommandStatus(intval($id));
} catch(\Homegear\HomegearException $e) {
    $code = $e->getCode();
    if ($code == -2) {
        // ID unknown
        echo json_encode(['status' => 'error', 'message' => 'id unknown']);
        exit(0);
    } elseif ($code == -32601) {
        // homegear-management not running
        echo json_encode(['status' => 'true', 'message' => 'management daemon not running']);
        exit(0);
    }
}
if (isset($result) && array_key_exists('finished',$result)) {
    if ($result['finished'] != 1) {
        // update still running
        // clean temporary files
        array_map('unlink', glob("/tmp/update*.txt"));
        echo json_encode(['status' => 'true']);
    } else {
        // update finished
        echo json_encode(['status' => 'false']);
    }
    exit(0);
}
echo json_encode(['status' => 'error', 'message' => 'unknown error']);
