<?php
Namespace App\Controller\Admin;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use App\Model\Admin\HomegearServiceMessage;

class LayoutController extends Controller
{
    private $user;

    public function header(Request $request, HomegearServiceMessage $messages)
    {
        $this->user = $this->getUser();
        return $this->render('Admin/header.html.twig', array(
            'locale' => $request->getSession()->get('_locale'),
            'currentUser' => $this->user->getUsername(),
            'serviceMessages' => $messages->list()
        ));
    }
    
    public function navigation($sect,$route)
    {
        $userSettings = \Homegear\Homegear::getUserMetadata($this->user->getUsername());

        $navigation = array();
        $routes = $this->get('router')->getRouteCollection();
        foreach ($routes as $key => $myRoute) {
            if (strpos($key, 'admin.') === 0) {
                $defaults = $myRoute->getDefaults();
                if(array_key_exists('expert', $defaults) && $defaults['expert'] === true && (!array_key_exists('expert', $userSettings) || $userSettings['expert'] !== "true")) continue;

                if(array_key_exists('name', $defaults) && $defaults['name'] == 'navigation.item.webssh') {
                    if(!call_user_func("Homegear\\Homegear::system.listMethods", "websshInput")) continue;
                    if(!$_SERVER['WEBSOCKET_ENABLED'] || $_SERVER['WEBSOCKET_AUTH_TYPE'] != 'session') continue;
                }

                if (array_key_exists('main_navigation', $defaults) && $defaults['main_navigation'] == 1) {
                    if ($defaults['sect'] == 'control' && array_key_exists('afterLogin',$userSettings)) {
                        $navigation[$defaults['sect']] = ['name' => $defaults['name'], 'path' => $userSettings['afterLogin'], 'icon' => $defaults['icon'], 'sort' => $defaults['sort'], 'sect' => $defaults['sect'], 'target' => (array_key_exists('target', $defaults) ? $defaults['target'] : '')];                        
                    } else {
                        $navigation[$defaults['sect']] = ['name' => $defaults['name'], 'path' => $key, 'icon' => $defaults['icon'], 'sort' => $defaults['sort'], 'sect' => $defaults['sect'], 'target' => (array_key_exists('target', $defaults) ? $defaults['target'] : '')];
                    }
                }
                if (array_key_exists('sub_navigation', $defaults) && $defaults['sub_navigation'] == 1) {
                    $navigation[$defaults['sect']]['sub_navigation'][$defaults['sort']] = ['name' => $defaults['name'], 'path' => $key, 'icon' => $defaults['icon'], 'sect' => $defaults['sect'], 'target' => (array_key_exists('target',$defaults) ? $defaults['target'] : '')];
                }
            }
        }
        foreach ($navigation as $key => $value) {
            $navigation[$value['sort']] = $navigation[$key];
            unset($navigation[$key]);
            if (array_key_exists('sub_navigation',$navigation[$value['sort']])) {
                ksort($navigation[$value['sort']]['sub_navigation']);
            }
        }
        ksort($navigation);
        return $this->render('Admin/navigation.html.twig', array(
            'sect' => $sect,
            'route' => $route,
            'navigation' => $navigation
        ));
    }
}