<?php
Namespace App\Controller\Admin\Maintenance;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use App\Utils\Utils;

class LogController extends Controller
{
    public function indexAction(Request $request, Utils $utils)
    {
        return $this->render('Admin/Maintenance/Logs/index.html.twig', array(
            'sect' => $request->attributes->get('sect')
        ));
    }

    public function downloadAction(Request $request)
    {
        $params = $request->request->all();
        if (array_key_exists('logfile', $params)) {
            $response = new Response();
            $response->headers->set('Cache-Control', 'private');
            $response->headers->set('Content-type', 'application/octect-stream');
            $response->headers->set('Content-Disposition', 'attachment; filename="' .$params['logfile']. '";');
            $response->headers->set('Content-length', filesize('/var/log/homegear/'.$params['logfile']));
            $response->sendHeaders();
            $response->setContent(file_get_contents('/var/log/homegear/'.$params['logfile']));
            return $response;
        }
    }

    public function viewAction(Request $request)
    {
        $params = $request->request->all();
        if (array_key_exists('logfile', $params)) {
            // really fast file-read, see https://gist.github.com/lorenzos/1711e81a9162320fde20
            $lines = ( array_key_exists('lines', $params) ? $params['lines'] : 100 );
            $adaptive = true;
            $filepath = '/var/log/homegear/'.$params['logfile'];
		    // Open file
		    $f = @fopen($filepath, "rb");
		    if ($f === false) return false;
		    // Sets buffer size, according to the number of lines to retrieve.
		    // This gives a performance boost when reading a few lines from the file.
		    if (!$adaptive) $buffer = 4096;
		    else $buffer = ($lines < 2 ? 64 : ($lines < 10 ? 512 : 4096));
		    // Jump to last character
		    fseek($f, -1, SEEK_END);
		    // Read it and adjust line number if necessary
		    // (Otherwise the result would be wrong if file doesn't end with a blank line)
		    if (fread($f, 1) != "\n") $lines -= 1;
		
		    // Start reading
		    $output = '';
		    $chunk = '';
		    // While we would like more
		    while (ftell($f) > 0 && $lines >= 0) {
			    // Figure out how far back we should jump
			    $seek = min(ftell($f), $buffer);
			    // Do the jump (backwards, relative to where we are)
			    fseek($f, -$seek, SEEK_CUR);
			    // Read a chunk and prepend it to our output
			    $output = ($chunk = fread($f, $seek)) . $output;
			    // Jump back to where we started reading
			    fseek($f, -mb_strlen($chunk, '8bit'), SEEK_CUR);
			    // Decrease our line counter
			    $lines -= substr_count($chunk, "\n");
		    }
		    // While we have too many lines
		    // (Because of buffer size we might have read too many)
		    while ($lines++ < 0) {
			    // Find first newline and remove all text before that
			    $output = substr($output, strpos($output, "\n") + 1);
		    }
		    // Close file and return
            fclose($f);
            $response = new Response();
            $response->setContent(nl2br($output));
		    return $response;
        }
    }
}