<?php
Namespace App\Controller\Admin;

use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use App\Model\Admin\HomegearServiceMessage;

class ServiceMessageController extends Controller
{

    public function indexAction(Request $request, HomegearServiceMessage $message)
    {
        return $this->render('Admin/servicemessages.html.twig', array(
            'sect' => $request->attributes->get('sect'),
            'messages' => $message->list(),
            'ignoredDevices' => $message->getIgnores()
        ));
    }

    public function deleteAction(Request $request, HomegearServiceMessage $message)
    {
        $params = $request->request->all();
        try
        {
            $message->delete($params['id'], $params['dp']);
        }
        catch(\Homegear\HomegearException $e)
        {
            return new JsonResponse(array("result" => "error", "message" => $e->getMessage()));
        }
        return new JsonResponse(array("result" => "ok"));
    }

    public function deleteAllAction(Request $request, HomegearServiceMessage $message)
    {
        try {
            $message->deleteAll();
        } catch(\Homegear\HomegearException $e) {
            return new JsonResponse(array("result" => "error", "message" => $e->getMessage()));
        }
        return new JsonResponse(array("result" => "ok"));
    }

    public function ignoreAction(Request $request, HomegearServiceMessage $message)
    {
        $params = $request->request->all();
        if (is_array($params) && array_key_exists('id',$params)) {
            try {
                $message->setIgnore($params['id']);
            } catch(\Homegear\HomegearException $e) { }
        }
        return $this->redirectToRoute('admin.servicemessages',array(),301);
    }

    public function unignoreAction($id, Request $request, HomegearServiceMessage $message)
    {
        try {
            $message->deleteIgnore($id);
        } catch(\Homegear\HomegearException $e) { }
        return $this->redirectToRoute('admin.servicemessages',array(),301);
    }
}